<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" xmlns:mobile="http://scenari.soreha.fr/sc-mobile" exclude-result-prefixes="sc sp of wm">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vArguments"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<!-- Récupère un paramètre passé par lors de l'appel de l'agent -->
	<xsl:template name="tGetParam">
		<xsl:param name="pName"/>
		<xsl:if test="string-length(normalize-space($pName))&gt;0 and string-length(normalize-space($vArguments))&gt;0">
			<xsl:value-of select="substring-before(substring-after($vArguments, concat($pName,'=')), ';')"/>
		</xsl:if>
	</xsl:template>
	<xsl:variable name="vUrl">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">url</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="vBaseUrl">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">baseUrl</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="vPubDate">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">pubDate</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	<xsl:template match="wm:montage">
		<xsl:variable name="vDesc" select="normalize-space(getContent(gotoSubModel(sp:notice),'desc'))"/>
		<xsl:variable name="vDuration" select="normalize-space(getContent(gotoSubModel(sp:segmentationFull),'duration'))"/>
		<xsl:variable name="vCopyright" select="wm:montageM/sp:commonMeta/of:commonM/sp:copyright"/>
		<xsl:variable name="vAuthor" select="normalize-space(getContent(gotoSubModel(sp:notice),'author'))"/>
		<xsl:variable name="vVersion" select="wm:montageM/sp:commonMeta/of:commonM/sp:version"/>
		<xsl:if test="$vDesc">
			<description>
				<xsl:value-of select="$vDesc"/>
			</description>
		</xsl:if>
				<mobile:mobileInf duration="{$vDuration}">
			<xsl:if test="$vAuthor">
				<xsl:attribute name="author">
					<xsl:value-of select="$vAuthor"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="$vVersion">
				<xsl:attribute name="version">
					<xsl:value-of select="$vVersion"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="$vCopyright">
			<xsl:attribute name="legal">
					<xsl:value-of select="$vCopyright"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:variable name="vCoverSmallContent" select="getContent(gotoSubModel(sp:notice), 'coverSmall')"/>
			<xsl:variable name="vCoverSmall" select="parseXml($vCoverSmallContent)/img"/>
			<xsl:variable name="vCoverLargeContent" select="getContent(gotoSubModel(sp:notice), 'coverLarge')"/>
			<xsl:variable name="vCoverLarge" select="parseXml($vCoverLargeContent)/img"/>
			<mobile:smartphoneLink>
				<xsl:value-of select="$vUrl"/>
			</mobile:smartphoneLink>
			<mobile:smallThumbnail url="{$vBaseUrl}/{$vCoverSmall/@src}" width="{$vCoverSmall/@width}" height="{$vCoverSmall/@height}"/>
			<mobile:largeThumbnail url="{$vBaseUrl}/{$vCoverLarge/@src}" width="{$vCoverLarge/@width}" height="{$vCoverLarge/@height}"/>
			<mobile:pubDate>
				<xsl:value-of select="$vPubDate"/>
			</mobile:pubDate>
			<mobile:lastBuildDate>
				<xsl:value-of select="$vPubDate"/>
			</mobile:lastBuildDate>
		</mobile:mobileInf>
	</xsl:template>
</xsl:stylesheet>