<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
	xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" xmlns="scpf.org:webMedia/sorehaPhone" exclude-result-prefixes="sc sp of wm java"
	xmlns:java="http://xml.apache.org/xslt/java">
	
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	
	<xsl:param name="vArguments" />
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>

	<xsl:param name="vArguments" />
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>

	<!-- Récupère un paramètre passé par lors de l'appel de l'agent -->
	<xsl:template name="tGetParam">
		<xsl:param name="pName"/>
		<xsl:if test="string-length(normalize-space($pName))&gt;0 and string-length(normalize-space($vArguments))&gt;0">
			<xsl:value-of select="substring-before(substring-after($vArguments, concat($pName,'=')), ';')"/>
		</xsl:if>
	</xsl:template>
	
	<xsl:variable name="vStart">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">start</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:template match="wm:part">
		<xsl:variable name="vFirstSegStart" select="(.//wm:segmentM//sp:begin)[1]" />
		<xsl:variable name="vLastSegEnd" select="(.//wm:segmentM//sp:end)[last()]" />
		<xsl:variable name="vDuration" select="$vLastSegEnd - $vFirstSegStart" />
		
		<chapter title="{getShortTitleText(currentModel(), 'index')}"
			start="{floor(($vStart + $vFirstSegStart) * 10) div 10}" end="{floor(($vStart + $vLastSegEnd) * 10) div 10}">
			<xsl:for-each select="sp:segment">
				<xsl:apply-templates select=".">
					<xsl:with-param name="pStart" select="$vStart + .//wm:segmentM//sp:begin" />
				</xsl:apply-templates>
			</xsl:for-each>
		</chapter>
	</xsl:template>

	<xsl:template match="sp:segment">
		<xsl:param name="pStart" />
		<xsl:value-of select="computeStrAgent(concat('@', gotoSubModel(), '_Aindex/xhtmlContent'),concat('start=', $pStart, ';'))" disable-output-escaping="yes" />
	</xsl:template>
	
	<xsl:template match="* | text()"/>
</xsl:stylesheet>
