<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
	xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:of="scpf.org:office" xmlns="scpf.org:webMedia/sorehaPhone" xmlns:wm="scpf.org:webMedia" exclude-result-prefixes="sc sp of wm java"
	xmlns:java="http://xml.apache.org/xslt/java">
	
	
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	
	<xsl:param name="vArguments" />
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>

	<!-- Récupère un paramètre passé par lors de l'appel de l'agent -->
	<xsl:template name="tGetParam">
		<xsl:param name="pName"/>
		<xsl:if test="string-length(normalize-space($pName))&gt;0 and string-length(normalize-space($vArguments))&gt;0">
			<xsl:value-of select="substring-before(substring-after($vArguments, concat($pName,'=')), ';')"/>
		</xsl:if>
	</xsl:template>
	
	<xsl:variable name="vStart">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">start</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:template match="wm:timeRange">
		<xsl:variable name="vDuration" select="wm:timeCode//sp:end - wm:timeCode//sp:begin" />
		<xsl:variable name="vEnd" select="$vStart + $vDuration" />
		
		<illustration start="{floor($vStart * 10) div 10}" end="{floor($vEnd * 10) div 10}">
			<xsl:apply-templates />
		</illustration>
	</xsl:template>
	
	<xsl:template match="sp:content">
		<xsl:variable name="vType" select="typeAgent(concat('@',gotoSubModel()))" />
		<xsl:choose>
			<xsl:when test="$vType = 'wm_illustrationText' or $vType = 'of_gallery'">
				<xsl:value-of select="getContent(gotoSubModel(), 'index')" disable-output-escaping="yes" />
			</xsl:when>
			<xsl:when test="$vType = 'sfile_gif' or $vType = 'sfile_jpg_jpeg' or $vType = 'sfile_png'">
				<xsl:variable name="$vTitle" select="normalize-space(getShortTitleText(gotoSubModel()))" />
				<image refUri="{getUrl(gotoSubModel(), 'gallery')}">
					<xsl:if test="string-length($vTitle)">
						<xsl:attribute name="title">
							<xsl:value-of select="$vTitle" />
						</xsl:attribute>
					</xsl:if>
				</image>
			</xsl:when>
			<xsl:otherwise>
				<!-- TODO : vidéo et animation non supporté : message dans le log --> </xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="* | text()" />
</xsl:stylesheet>
