<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:of="scpf.org:office" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:java="http://xml.apache.org/xslt/java" exclude-result-prefixes="sc sp java of" version="1.0">
	<xsl:output omit-xml-declaration="yes" indent="no" method="xml"/>
	<xsl:param name="vAgent"/>
	<xsl:param name="vDialog"/>
	<xsl:template match="*">
		<xsl:if test="checkNoCycleAgent()">
			<xsl:apply-templates mode="in_N8"/>
		</xsl:if>
	</xsl:template>
	<xsl:template mode="in_N8" match="*"/>
	<xsl:template mode="in_N8" match="sp:info">
		<scBlock class="bkBase bkInfo">
			<ifText>
				<hx class="bkBase_ti">
					<span>
						<xsl:value-of select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/fullTitleText'))"/>
					</span>
				</hx>
			</ifText>
			<div class="bkBase_co ">
				<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/xhtmlContent'))"/>
			</div>
		</scBlock>
	</xsl:template>
	<xsl:template mode="in_N8" match="sp:emphasis">
		<scBlock class="bkBase bkEmphasis">
			<ifText>
				<hx class="bkBase_ti">
					<span>
						<xsl:value-of select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/fullTitleText'))"/>
					</span>
				</hx>
			</ifText>
			<div class="bkBase_co ">
				<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/xhtmlContent'))"/>
			</div>
		</scBlock>
	</xsl:template>
	<xsl:template mode="in_N8" match="sp:extra">
		<xsl:variable name="titreCompl">
			<xsl:choose>
				<xsl:when test="of:block/of:blockM/sp:title!=''">
					<xsl:value-of select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/fullTitleText'))"/>
				</xsl:when>
				<xsl:otherwise>En complément...</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<a class="buttonExtra" href="openExtra:{getUrl(gotoSubModel(), 'extra')}:{$titreCompl}">
			<xsl:value-of select="$titreCompl"/>
		</a>
		<!--		<scBlock class="bExtra bkExtra">
			<ifText>
				<hx class="bExtra_ti">
					<span>
						<xsl:value-of select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/fullTitleText'))"/>
					</span>
				</hx>
			</ifText>
			<div class="bExtra_co ">
				<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/xhtmlContent'))"/>
			</div>
		</scBlock>-->
	</xsl:template>
	<xsl:template mode="in_N8" match="sp:evtList">
		<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/xhtmlContent'))"/>
	</xsl:template>
	<xsl:template mode="in_N8" match="sp:gallery">
		<scBlock class="bkBase bkGallery">
			<ifText>
				<hx class="bkBase_ti">
					<span>
						<xsl:value-of select="resultatAgent(concat('@', switchAxis(codeAgent('//'), ''), '/fullTitleText'))"/>
					</span>
				</hx>
			</ifText>
			<div class="bkBase_co ">
					<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '_Apresentation/xhtmlContent'))"/>
					<a class="openGallery" href="openGallery:{count(preceding::sp:gallery)}">
					<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '_Adisplay/xhtmlContent'))"/>
					<div class="messageOpenGal"><span>Lancer la galerie (<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '_AnbrImgGal/xhtmlContent'))"/>)</span></div>
					</a>
			</div>
		</scBlock>
	</xsl:template>
	<xsl:template mode="in_N8" match="sp:frag">
		<xsl:value-of disable-output-escaping="yes" select="resultatAgent(concat('@', si(@sc:refUri, getIdFromPath(@sc:refUri), getIdNode(.)), '/xhtmlContent'))"/>
	</xsl:template>
	<xsl:template match="text()"/>
</xsl:stylesheet>