<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:wm="scpf.org:webMedia"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="sc sp">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes" />

	<xsl:param name="vDialog" />
	<xsl:param name="vAgent" />

	<xsl:template name="tFormatDuration">
		<xsl:param name="pDuration" />

		<xsl:variable name="vHours" select="floor($pDuration div 3600)" />
		<xsl:variable name="vMinutes" select="floor($pDuration mod 3600 div 60)" />
		<xsl:variable name="vSeconds" select="round($pDuration mod 60)" />

		<xsl:if test="$vHours">
			<xsl:value-of select="$vHours" />
			<xsl:text>:</xsl:text>
		</xsl:if>
		<xsl:if test="$vHours and $vMinutes &lt; 10">
			<xsl:text>0</xsl:text>
		</xsl:if>
		<xsl:value-of select="$vMinutes" />
		<xsl:text>:</xsl:text>
		<xsl:if test="$vSeconds &lt; 10">
			<xsl:text>0</xsl:text>
		</xsl:if>
		<xsl:value-of select="$vSeconds" />

	</xsl:template>

	<xsl:template match="wm:timeCode">
		<td class="fmtBegin">
			<xsl:call-template name="tFormatDuration">
				<xsl:with-param name="pDuration" select="sp:begin" />
			</xsl:call-template>
		</td>
		<td class="fmtEnd">
			<xsl:call-template name="tFormatDuration">
				<xsl:with-param name="pDuration" select="sp:end" />
			</xsl:call-template>
		</td>
	</xsl:template>
</xsl:stylesheet>
