<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" exclude-result-prefixes="sc sp of wm">
	
	<xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:param name="vArguments"/>
	
	<!-- Récupère un paramètre passé par lors de l'appel de l'agent -->
	<xsl:template name="tGetParam">
		<xsl:param name="pName"/>
		<xsl:if test="string-length(normalize-space($pName))&gt;0 and string-length(normalize-space($vArguments))&gt;0">
			<xsl:value-of select="substring-before(substring-after($vArguments, concat($pName,'=')), ';')"/>
		</xsl:if>
	</xsl:template>
	
	<xsl:variable name="vBegin">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">begin</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:variable name="vEnd">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">end</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:variable name="vHasCplt">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">hasCplt</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:variable name="vTimeRangeId">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">timeRangeId</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:template match="of:gallery">
		<xsl:variable name="vImgDuration" select="($vEnd - $vBegin) div count(sp:img)" />
		<xsl:for-each select="sp:img">
			<xsl:apply-templates select=".">
				<xsl:with-param name="pBegin" select="$vBegin + ($vImgDuration * (position() - 1))" /> 
				<xsl:with-param name="pEnd" select="$vBegin + ($vImgDuration * position())" /> 
			</xsl:apply-templates>
			<xsl:if test="position() != last()">,</xsl:if>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template match="sp:img">
		<xsl:param name="pBegin" />
		<xsl:param name="pEnd" />
		
		<xsl:variable name="vTarget" select="concat($vTimeRangeId, '_gallery_', alphaHash(gotoSubModel()), getDialogVar('montagePos'))"/>
		<xsl:text>{"start":</xsl:text>
		<xsl:value-of select="$pBegin"/>
		<xsl:text>,"end":</xsl:text>
		<xsl:value-of select="$pEnd"/>
		<xsl:text>,"hasContent":true</xsl:text>
		<xsl:text>,"hasCplt":</xsl:text>
		<xsl:value-of select="$vHasCplt" />
		<xsl:text>,"target":"</xsl:text>
		<xsl:value-of select="$vTarget"/>
		<xsl:text>"}</xsl:text>
	</xsl:template>

</xsl:stylesheet>