<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	exclude-result-prefixes="sc sp">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes" />
	<xsl:param name="vDialog" />
	<xsl:param name="vAgent" />
	<xsl:template match="*">
		<mediaAttributes>
			<xsl:apply-templates select="//sp:transcript" />
			<xsl:if test="//sp:audioDesc">
				<xsl:variable name="vAudioDescType" select="getContent(gotoSubModel(//sp:audioDesc),'type')" />
				<xsl:choose>
					<xsl:when test="$vAudioDescType = 'audio'">
						<xsl:attribute name="data-alt-audiodescType">
							<xsl:text>stream</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="data-alt-audiodesc">
							<xsl:value-of select="getUrl(gotoSubModel(//sp:audioDesc),'nav')" />
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="data-alt-audiodescType">
							<xsl:text>subwindow</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="data-alt-audiodesc">
							<xsl:value-of select="getUrl(gotoSubModel(//sp:audioDesc),'sub')" />
						</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
			<xsl:if test="//sp:altVideo">
				<xsl:attribute name="data-alt-altvideo">
					<xsl:value-of select="getUrl(gotoSubModel(//sp:altVideo),'sub')" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="//sp:subTitles">
				<xsl:attribute name="data-subtitles">{"subtitles":[<xsl:for-each select="//sp:subTitles">{"lang":"<xsl:value-of select="sp:lang" />","url":"<xsl:value-of
					select="getUrl(gotoSubModel(sp:subTitle),'nav')" />","format":"<xsl:value-of select="substring-after(typeAgent(concat('@',gotoSubModel(sp:subTitle))), 'sfile_')"/>"}<xsl:value-of select="if(following-sibling::sp:subTitles,',')" />
					</xsl:for-each>]}</xsl:attribute>
			</xsl:if>
		</mediaAttributes>
	</xsl:template>

	<xsl:template match="sp:transcript">
		<xsl:variable name="vType" select="typeAgent(concat('@',gotoSubModel()))" />
		<xsl:choose>
			<xsl:when test="$vType = 'wm_transcript'">
				<xsl:attribute name="data-alt-transcript-type">
					<xsl:text>content</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="data-alt-transcript-id">
					<xsl:value-of select="alphaHash(getIdNode(.))" />
				</xsl:attribute>
			</xsl:when>
			<xsl:when test="$vType = 'sfile_vtt'">
				<xsl:attribute name="data-alt-transcript-type">
					<xsl:text>subtitle</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="data-alt-transcript-format">
					<xsl:value-of select="substring-after($vType, 'sfile_')" />
				</xsl:attribute>
				<xsl:attribute name="data-alt-transcript-id">
					<xsl:value-of select="alphaHash(getIdNode(.))" />
				</xsl:attribute>
				<xsl:attribute name="data-alt-transcript-url">
					<xsl:value-of select="getUrl(gotoSubModel(),'nav')" />
				</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="data-alt-transcript-type">
					<xsl:text>nav</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="data-alt-transcript-url">
					<xsl:value-of select="getUrl(gotoSubModel(),'nav')" />
				</xsl:attribute>
				<xsl:attribute name="data-alt-transcript-infos">
					<xsl:value-of select="getContent(gotoMeta(gotoSubModel()))" />
				</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>