<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" xmlns:xalan="http://xml.apache.org/xalan" exclude-result-prefixes="sc sp of wm">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:variable name="vOptionsContent" select="getContent(gotoMeta(rootModel()), 'options')"/>
	<xsl:variable name="vOptions" select="parseXml($vOptionsContent)/wm:optsPubHtmlM"/>
	<xsl:variable name="vForcedMediaType" select="$vOptions/sp:forcedMediaType"/>
	<xsl:template match="wm:altMediaM">
		<xsl:choose>
			<xsl:when test="sp:altStream">
				<xsl:apply-templates select="sp:altStream"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="sp:altOggWebM">
						<xsl:apply-templates select="sp:altOggWebM"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$vForcedMediaType = 'video'">
								<xsl:call-template name="tCallBinaryModel">
									<xsl:with-param name="pTypes">sfile_ogv sfile_webm</xsl:with-param>
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="$vForcedMediaType = 'audio'">
								<xsl:call-template name="tCallBinaryModel">
									<xsl:with-param name="pTypes">sfile_oga_ogg</xsl:with-param>
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="tCallBinaryModel">
									<xsl:with-param name="pTypes">sfile_ogv sfile_webm sfile_oga_ogg</xsl:with-param>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="sp:altMpeg">
						<xsl:apply-templates select="sp:altMpeg"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$vForcedMediaType = 'video'">
								<xsl:call-template name="tCallBinaryModel">
									<xsl:with-param name="pTypes">sfile_mp4_f4v</xsl:with-param>
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="$vForcedMediaType = 'audio'">
								<xsl:call-template name="tCallBinaryModel">
									<xsl:with-param name="pTypes">sfile_mp3</xsl:with-param>
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="tCallBinaryModel">
									<xsl:with-param name="pTypes">sfile_mp4_f4v sfile_mp3</xsl:with-param>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
				<!-- xsl:apply-templates select="sp:altMedia"/  -->
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="sp:altStream | sp:altOggWebM | sp:altMpeg | sp:altMedia">
		<xsl:variable name="vMediaType" select="getContent(gotoSubModel(), 'type')"/>
		<xsl:if test="not($vForcedMediaType) or $vForcedMediaType = $vMediaType">
			<xsl:value-of select="getContent(gotoSubModel(), 'altMedia')" disable-output-escaping="yes"/>
		</xsl:if>
	</xsl:template>
	<xsl:template name="tCallBinaryModel">
		<xsl:param name="pTypes"/>
		<xsl:variable name="vTypesParams">
			<xsl:for-each select="xalan:tokenize($pTypes, ' ')">
				<xsl:text>,'</xsl:text>
				<xsl:value-of select="."/>
				<xsl:text>'</xsl:text>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="vAscendants" select="xalan:evaluate(concat('lookForAscendants($vDialog, &quot;currentToRoot&quot;', $vTypesParams, ')'))"/>
		<xsl:value-of select="computeStrAgent(concat(concat('@', switchAxis(codeAgent($vAscendants), 'altMedia')), '/xhtmlContent'))" disable-output-escaping="yes"/>
	</xsl:template>
</xsl:stylesheet>