<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" exclude-result-prefixes="sc sp of wm">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>

	<xsl:variable name="vOptionsContent" select="getContent(gotoMeta(rootModel()), 'options')" />
	<xsl:variable name="vOptions" select="parseXml($vOptionsContent)/wm:optsPubHtmlM" />

	<xsl:template match="wm:montage">
		<xsl:variable name="vDurationsContent" select="getContent(currentModel(), 'durations')"/>
		<xsl:variable name="vDurations" select="parseXml($vDurationsContent)/durations"/>
		<script id="segmentsData" type="application/json">
			<xsl:text>[</xsl:text>
			<xsl:for-each select="sp:segmentationFull | sp:segment">
				<xsl:variable name="vPosition" select="position()"/>
				<xsl:apply-templates select="." mode="segmentsData">
					<xsl:with-param name="pPosition" select="$vPosition" />
					<xsl:with-param name="pStart" select="sum($vDurations/duration[position() &lt; $vPosition])"/>
				</xsl:apply-templates>
				<xsl:if test="position() != last()">,</xsl:if>
			</xsl:for-each>
			<xsl:text>]</xsl:text>
		</script>
		<script id="timeRangesData" type="application/json">
			<xsl:text>[</xsl:text>
			<xsl:for-each select="sp:segmentationFull | sp:segment">
				<xsl:variable name="vPosition" select="position()"/>
				<xsl:apply-templates select="." mode="timeRangesData">
					<xsl:with-param name="pPosition" select="$vPosition" />
					<xsl:with-param name="pStart" select="sum($vDurations/duration[position() &lt; $vPosition])"/>
				</xsl:apply-templates>
				<xsl:if test="position() != last()">,</xsl:if>
			</xsl:for-each>
			<xsl:text>]</xsl:text>
		</script>
		<script id="navData" type="application/json">
			<xsl:variable name="vNavLevel" select="$vOptions/sp:navLevel" />
			<xsl:text>{</xsl:text>
			<xsl:text>&quot;navLevel&quot;:&quot;</xsl:text>
			<xsl:value-of select="if($vNavLevel, $vNavLevel, 'segment')" />
			<xsl:text>&quot;</xsl:text>
			<xsl:text>}</xsl:text>
		</script>
	</xsl:template>
	<xsl:template match="sp:segmentationFull | sp:segment" mode="segmentsData">
		<xsl:param name="pPosition"/>
		<xsl:param name="pStart"/>
		<xsl:value-of select="execute(setDialogVar('montagePos', $pPosition))" />
		<xsl:variable name="vRefId" select="wm:subSegmentRef/wm:subSegmentRefM/sp:refId"/>
		<xsl:variable name="vSubModel" select="if(self::sp:segment, wm:subSegmentRef/wm:subSegmentRefM/sp:refItem, .)"/>
		<xsl:value-of select="computeStrAgent(concat('@', gotoSubModel($vSubModel), '_AsegmentsData/xhtmlContent'),concat('refId=', $vRefId, ';start=', $pStart, ';'))"/>
	</xsl:template>
	<xsl:template match="sp:segmentationFull | sp:segment" mode="timeRangesData">
		<xsl:param name="pPosition"/>
		<xsl:param name="pStart"/>
		<xsl:value-of select="execute(setDialogVar('montagePos',$pPosition))" />
		<xsl:variable name="vRefId" select="wm:subSegmentRef/wm:subSegmentRefM/sp:refId"/>
		<xsl:variable name="vSubModel" select="if(self::sp:segment, wm:subSegmentRef/wm:subSegmentRefM/sp:refItem, .)"/>
		<xsl:value-of select="computeStrAgent(concat('@', gotoSubModel($vSubModel), '_AtimeRangesData/xhtmlContent'),concat('refId=', $vRefId, ';start=', $pStart, ';'))"/>
	</xsl:template>
</xsl:stylesheet>