<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" exclude-result-prefixes="sc sp of wm">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:param name="vArguments"/>
	<xsl:variable name="vOptionsContent" select="getContent(gotoMeta(rootModel()), 'options')"/>
	<xsl:variable name="vOptions" select="parseXml($vOptionsContent)/wm:optsPubHtmlM"/>
	<xsl:template match="wm:montage">
		<xsl:variable name="vDurationsContent" select="getContent(currentModel(), 'durations')"/>
		<xsl:variable name="vDuration" select="sum(parseXml($vDurationsContent)/durations/duration)"/>
		<xsl:variable name="vMarginToc" select="$vOptions/sp:tocPos = 'margin'"/>
		<xsl:variable name="vMarginTags" select="$vOptions/sp:tagsPos = 'margin'"/>
		<xsl:choose>
			<xsl:when test="($vMarginToc) or ($vMarginTags)">
				<xsl:attribute name="class">
					<xsl:value-of select="'marginWithToc'"/>
				</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="class">
					<xsl:value-of select="'marginNoToc'"/>
				</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="$vMarginToc">
			<div id="marginToc">
				<xsl:if test="not($vMarginTags)">
					<xsl:attribute name="class">seul</xsl:attribute>
				</xsl:if>
				<xsl:value-of select="getContent(currentModel(), 'toc')" disable-output-escaping="yes"/>
			</div>
		</xsl:if>
		<xsl:if test="$vMarginTags">
			<div id="marginTags">
				<xsl:if test="not($vMarginToc)">
					<xsl:attribute name="class">seul</xsl:attribute>
				</xsl:if>
				<xsl:value-of select="getContent(currentModel(), 'tags')" disable-output-escaping="yes"/>
			</div>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>