<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" exclude-result-prefixes="sc sp of wm">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:variable name="vOptionsContent" select="getContent(gotoMeta(rootModel()), 'options')"/>
	<xsl:variable name="vOptions" select="parseXml($vOptionsContent)/wm:optsPubHtmlM"/>
	<xsl:template match="wm:montage">
		<xsl:choose>
			<xsl:when test="count(sp:segmentationFull) = 1 and not(sp:segment)">
				<div id="mediafull">
					<xsl:attribute name="data-currenttype">
						<xsl:choose>
							<xsl:when test="$vOptions/sp:forcedMediaType">
								<xsl:value-of select="$vOptions/sp:forcedMediaType" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="getContent(gotoSubModel(sp:segmentationFull), 'type')" disable-output-escaping="yes"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
					<xsl:apply-templates select="sp:segmentationFull">
						<xsl:with-param name="pStandalone" select="true()"/>
					</xsl:apply-templates>
					<button id="videoPlayPause" title="Lecture">
						<span>Lecture</span>
					</button>
				</div>
			</xsl:when>
			<xsl:otherwise>
				<div id="media" data-sequencer="true">
					<!-- <xsl:choose>
						<xsl:when test="$vOptions/sp:autoplay = 'no' "/>
						<xsl:otherwise>
							<xsl:attribute name="data-autoplay">true</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose> -->
					<xsl:apply-templates select="sp:segmentationFull | sp:segment"/>
					<button id="videoPlayPause" title="Lecture">
						<span>Lecture</span>
					</button>
				</div>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="sp:segmentationFull | sp:segment">
		<xsl:param name="pStandalone" select="false()"/>
		<xsl:value-of select="execute(setDialogVar('montagePos', position()))"/>
		<xsl:variable name="vRefId" select="wm:subSegmentRef/wm:subSegmentRefM/sp:refId"/>
		<xsl:variable name="vSubModel" select="if(self::sp:segment, wm:subSegmentRef/wm:subSegmentRefM/sp:refItem, .)"/>
		<xsl:value-of select="computeStrAgent(concat('@', gotoSubModel($vSubModel), '_Amedia/xhtmlContent'), concat('refId=', $vRefId, ';standalone=', $pStandalone, ';'))" disable-output-escaping="yes"/>
	</xsl:template>
</xsl:stylesheet>