<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" exclude-result-prefixes="sc sp of wm">
	<xsl:output method="text"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:param name="vArguments"/>
	<!-- Récupère un paramètre passé par lors de l'appel de l'agent -->
	<xsl:template name="tGetParam">
		<xsl:param name="pName"/>
		<xsl:if test="string-length(normalize-space($pName))&gt;0 and string-length(normalize-space($vArguments))&gt;0">
			<xsl:value-of select="substring-before(substring-after($vArguments, concat($pName,'=')), ';')"/>
		</xsl:if>
	</xsl:template>
	<xsl:variable name="vRefId">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">refId</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="vStart">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">start</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	<xsl:template match="wm:segmentation">
		<xsl:choose>
			<xsl:when test="$vRefId">
				<xsl:for-each select=".//sp:timeRange[ancestor::sp:segment[wm:segment/wm:segmentM/sp:id=$vRefId]]">
					<xsl:apply-templates select=".">
						<xsl:with-param name="pParentStart" select="$vStart"/>
					</xsl:apply-templates>
					<xsl:if test="position() != last()">,</xsl:if>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select=".//sp:timeRange">
					<xsl:apply-templates select=".">
						<xsl:with-param name="pParentStart" select="$vStart + ./ancestor::wm:segment/wm:segmentM//sp:begin"/>
					</xsl:apply-templates>
					<xsl:if test="position() != last()">,</xsl:if>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="sp:timeRange">
		<xsl:param name="pParentStart"/>
		<xsl:variable name="vBegin" select="$pParentStart + wm:timeRange/wm:timeCode/sp:begin"/>
		<xsl:variable name="vEnd" select="$pParentStart + wm:timeRange/wm:timeCode/sp:end"/>
		<xsl:variable name="vTarget" select="concat('timeRange_', alphaHash(gotoSubModel()), getDialogVar('montagePos'))"/>
		<xsl:variable name="vType" select="typeAgent(concat('@',gotoSubModel(wm:timeRange/sp:content)))"/>
		<xsl:variable name="vHasCplt" select="../sp:marginNotes or ../sp:complement" />
		<xsl:text>{"start":</xsl:text>
		<xsl:value-of select="round($vBegin * 1000) div 1000"/>
		<xsl:text>,"end":</xsl:text>
		<xsl:value-of select="round($vEnd * 1000) div 1000"/>
		<xsl:text>,"hasContent":</xsl:text>
		<xsl:value-of select=".//sp:content  or ../sp:description"/>
		<xsl:if test="$vHasCplt">
			<xsl:text>,"hasCplt":true</xsl:text>
		</xsl:if>
		<xsl:text>,"target":"</xsl:text>
		<xsl:value-of select="$vTarget"/>
		<xsl:text>"}</xsl:text>
		<xsl:if test="$vType = 'of_gallery'">
			<xsl:text>,</xsl:text>
			<xsl:value-of select="computeStrAgent(concat('@', gotoSubModel(wm:timeRange/sp:content), '_AtimeRangesData/xhtmlContent'), concat('begin=', $vBegin, ';end=', $vEnd, ';hasCplt=', $vHasCplt, ';timeRangeId=', $vTarget, ';'))" disable-output-escaping="yes"/>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>