<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" exclude-result-prefixes="sc sp of wm">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="wm:montage">
		<xsl:variable name="vTagsContent">
			<xsl:text>&lt;dl&gt;</xsl:text>
			<xsl:apply-templates select="sp:segmentationFull | sp:segment"/>
			<xsl:text>&lt;/dl&gt;</xsl:text>
		</xsl:variable>
		<xsl:variable name="vTags" select="parseXml($vTagsContent)/dl"/>
		<div id="tags">
			<div  id="tagsContent">
				<xsl:apply-templates select="$vTags"/>
			</div>
			<div id="tagsPlayerButtons">
				<button id="nonContinuousPlayBtn" title="Lecture bout à bout">
					<span>Lecture bout à bout</span>
				</button>
			</div>
		</div>
	</xsl:template>
	<xsl:template match="sp:segmentationFull | sp:segment">
		<xsl:value-of select="execute(setDialogVar('montagePos', position()))" />
		<xsl:variable name="vRefId" select="wm:subSegmentRef/wm:subSegmentRefM/sp:refId"/>
		<xsl:variable name="vSubModel" select="si(self::sp:segment, wm:subSegmentRef/wm:subSegmentRefM/sp:refItem, .)"/>
		<xsl:value-of select="resultatAgent(concat('@', gotoSubModel($vSubModel), '_Atags/xhtmlContent'), concat('refId=', $vRefId, ';'))" disable-output-escaping="yes"/>
	</xsl:template>
	<xsl:template match="dl">
		<xsl:copy>
			<xsl:apply-templates select="@*"/>
			<xsl:apply-templates select="dt">
				<xsl:sort data-type="text" select="."/>
			</xsl:apply-templates>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="dt">
		<xsl:if test="not(preceding-sibling::dt[. = current()])">
			<xsl:copy>
				<xsl:apply-templates select="@* | addAttribute"/>
				<xsl:apply-templates select="*[not(self::addAttribute)] | text()"/>
			</xsl:copy>
			<xsl:apply-templates select="(following-sibling::dd)[1]"/>
		</xsl:if>
	</xsl:template>
	<xsl:template match="node() | @*">
		<xsl:copy>
			<xsl:apply-templates select="node() | @*"/>
		</xsl:copy>
	</xsl:template>
</xsl:stylesheet>