<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
	xmlns:of="scpf.org:office" xmlns:itunes="http://www.itunes.com/dtds/podcast-1.0.dtd" xmlns:wm="scpf.org:webMedia"
	exclude-result-prefixes="sc sp of wm">
	
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	
	<xsl:param name="vArguments" />
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	
	<!-- Récupère un paramètre passé par lors de l'appel de l'agent -->
	<xsl:template name="tGetParam">
		<xsl:param name="pName" />
		<xsl:if
			test="string-length(normalize-space($pName))&gt;0 and string-length(normalize-space($vArguments))&gt;0">
			<xsl:value-of
				select="substring-before(substring-after($vArguments, concat($pName,'=')), ';')" />
		</xsl:if>
	</xsl:template>
	
	<xsl:variable name="vUrl">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">url</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>

	<xsl:variable name="vBaseUrl">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">baseUrl</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:variable name="vPubDate">
		<xsl:call-template name="tGetParam">
			<xsl:with-param name="pName">pubDate</xsl:with-param>
		</xsl:call-template>
	</xsl:variable>
	
	<xsl:template match="wm:montage">
		<xsl:variable name="vMediaUri" select="normalize-space(getContent(gotoSubModel(sp:segmentationFull), 'stream'))" />
		<xsl:variable name="vNoticeDesc" select="normalize-space(getContent(gotoSubModel(sp:notice),'desc'))" />
		<xsl:variable name="vDuration" select="getContent(gotoSubModel(sp:segmentationFull),'fmtDuration')" />

		<xsl:variable name="vMediaErrorDesc" select="'Erreur : le média ou une de ses alternatives doit être au format MP3.'" />
		<xsl:variable name="vDesc" select="if($vMediaUri, $vNoticeDesc, $vMediaErrorDesc)" />
		
		<enclosure url="{concat($vBaseUrl, '/', $vMediaUri)}" type="audio/mpeg" />
		<xsl:if test="$vDesc">
			<description>
				<xsl:value-of select="$vDesc" />
			</description>
			<itunes:subtitle>
				<xsl:value-of select="$vDesc" />
			</itunes:subtitle>
		</xsl:if>
		<itunes:duration>
			<xsl:value-of select="$vDuration" />
		</itunes:duration>

		<itunes:image href="{$vBaseUrl}/{getUrl(gotoSubModel(sp:notice), 'cover')}" />
	</xsl:template>
</xsl:stylesheet>
