<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wm="scpf.org:webMedia" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:java="http://xml.apache.org/xslt/java" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" exclude-result-prefixes="wm sp java">

	<xsl:param name="srcNode"/>

	<xsl:template match="text()|@*"/>
	
	<xsl:template match="/sc:item">
		<xsl:variable name="vSeparator">'</xsl:variable>
		<xsl:variable name="vSegmentIds" select="//wm:segmentM/sp:id" />
		<xsl:if test="count($vSegmentIds)">
			<attrStr nm="segmentList">
				<xsl:value-of select="$vSeparator"/>
				<xsl:value-of select="concatExpr($vSegmentIds, ., $vSeparator)"/>
				<xsl:value-of select="$vSeparator"/>
			</attrStr>
		</xsl:if>
		<xsl:apply-templates select="$vSegmentIds" />
	</xsl:template>
	
	<xsl:template match="wm:segmentM/sp:id">
		<xsl:if test="preceding::wm:segmentM/sp:id = .">
			<cPbs>
				<pb typ="Error" msg="La segmentation possède deux Id de segment identiques : {.}." />
			</cPbs>
		</xsl:if>
		<xsl:if test="not(java:java.util.regex.Pattern.matches('^[\w]+$', string(.)))">
			<cPbs>
				<pb typ="Error" msg="Le format de l'Id n'est pas autorisé : {.}" />
			</cPbs>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>