<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:op="utc.fr:ics/opale3" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:java="http://xml.apache.org/xslt/java" xmlns:wm="scpf.org:webMedia" xmlns:of="scpf.org:office" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" exclude-result-prefixes="op java wm of sp " >

<xsl:param name="vSrcNode"/>

<xsl:template match="text()|@*"/>
<xsl:template match="*[@sc:refUri]">
<attrRef nm="?" refUri="{@sc:refUri}"/>
</xsl:template>

<xsl:template match="/sc:item">
<xsl:apply-templates select="wm:montage"/>
</xsl:template>

<xsl:template match="sc:item/wm:montage">
	<title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="wm:montageM"><xsl:value-of select="sp:title"/></xsl:for-each></title>
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>



			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:montage/sp:segmentationFull[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="wm_montage:segmentationFull"/>
<xsl:apply-templates/>
</xsl:template>
			
				
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:montage/sp:extras[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="wm_montage:extras"/>
<xsl:apply-templates/>
</xsl:template>
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:montage/sp:notice[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="wm_montage:notice"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:montage/sp:credits[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="wm_montage:credits"/>
<xsl:apply-templates/>
</xsl:template>

			
		
			
		
		
			
			
				
			
			
				
			
		
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='url'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:sTxt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='special'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:sTxt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:sTxt]">
<attrRef refUri="{@sc:refUri}" nm="of_sTxt:inlineImgTag:ico"/>
</xsl:template>
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:sTxt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:urlM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
		
			
			
				
				
			
			
				
				
			
			
				
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:langM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:txtM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:noticeM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
				
			
			
				
			
			
				
			
		
			
				
			
			
				
			
			
				
			
		
			
		
			
		
			
		
			
		
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:noticeM/sp:cover[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="wm_noticeM:cover:"/>
</xsl:template>
		
<xsl:template match="wm:subSegmentRefM/sp:refItem[@sc:refUri]">
     <xsl:variable name="vSeparator">'</xsl:variable>
     <attrRef nm="wm_subSegmentRefM:refItem:" refUri="{@sc:refUri}">
         <params>
                  <xsl:value-of select="$vSeparator"/>
                  <xsl:value-of select="following-sibling::sp:refId"/>
                  <xsl:value-of select="$vSeparator"/>
         </params>
     </attrRef>
</xsl:template>

			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:section/sp:sec[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:sec' or name()='sp:subSec')]">
<cPbs><pb typ="Error" msg="Un item a été référencé plusieurs fois !">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item &apos;&apos;%s&apos;&apos;.', java:com.scenari.m.bdp.item.fs.WspSrcUtil.getUiUriFromSrcUri(resolveSrcPath(@sc:refUri)))"/>
</pb></cPbs>
</xsl:if>
<attrRef refUri="{@sc:refUri}" nm="of_section:sec"/>
<xsl:apply-templates/>
</xsl:template>
		
			
		
			
			
			
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:gallery[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="of_fragment:gallery"/>
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:frag[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="of_fragment:frag"/>
<xsl:apply-templates/>
</xsl:template>
		
			
		
			
		
		
			
			
				
			
			
				
			
			
				
				
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role=''][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='head'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='total'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				
				
				
			
			
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role='layout'][@role=''][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
				
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='img'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:extBlockTag:img"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='anim'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:extBlockTag:anim"/>
</xsl:template>
		
		
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='def'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:uLinkTag:def"/>
<xsl:apply-templates/>
</xsl:template>
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='doc'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:uLinkTag:doc"/>
<xsl:apply-templates/>
</xsl:template>
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:uLinkTag:ref"/>
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='url'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='special'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef refUri="{@sc:refUri}" nm="of_txt:inlineImgTag:ico"/>
</xsl:template>
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:txt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:blockM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:filter">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
				
				
				
			
		
			
			
			
		
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:eventM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:eventListM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
				
				
			
		
			
			
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:gallery/sp:img[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="of_gallery:img"/>
<xsl:apply-templates/>
</xsl:template>
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:galleryM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:treeM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:treeM/sp:ico[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="of_treeM:ico:"/>
</xsl:template>
		
			
			
				
				
			
		
			
			
		
			
			
				
				
				
				
				
				
				
					
					
					
				
				
					
					
					
				
				
					
					
					
					
				
				
					
					
					
					
					
					
					
					
					
					
				
				
					
					
					
					
					
					
					
					
				
				
					
					
					
					
					
					
				
				
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:sectionM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:montageM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:montageM/sp:optsPub/sp:logo[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="wm_montageM:optsPub:logo:"/>
</xsl:template>
			
			
				
			
			
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:commonM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:licenseM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
				
				
				
				
				
				
				
				
				
				
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:optsPubHtmlM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
				
				
				
			
		
			
			
				
				
				
			
		
			
			
				
				
			
		
			
				
				
			
		
			
				
				
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="wm:optsPubHtmlM/sp:poster[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="wm_optsPubHtmlM:poster:"/>
</xsl:template>
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:webRootM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
				
				
			
		
			
				
				
			
		
			
				
				
			
		

</xsl:stylesheet>