<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:sfm="http://www.utc.fr/ics/scenari/v3/filemeta" 
	xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:wr="scpf.org:webRadio"
	xmlns:of="scpf.org:office" xmlns:wm="scpf.org:webMedia" xmlns:xalan="http://xml.apache.org/xalan" xmlns:redirect="http://xml.apache.org/xalan/redirect"
	extension-element-prefixes="redirect xalan redirect">

	<xsl:output encoding="UTF-8" indent="yes" method="xml" />

	<xsl:strip-space elements="*" />
	
	<xsl:param name="pCurrentItemUri" />
	
	<xsl:template match="of:richStream">
		<wm:montage>
			<xsl:apply-templates select="of:richStreamM" />
			
			<sp:segmentationFull sc:refUri="/{concat(substring-before($pCurrentItemUri, '.montage.xml'), '.xml')}" />
			
			<xsl:apply-templates select="sp:extras | sp:credits" />
			<xsl:apply-templates select="sp:summary" />
		</wm:montage>
	</xsl:template>
	
	<xsl:template match="of:richStreamM">
		<wm:montageM>
			<xsl:apply-templates select="sp:title | sp:commonM | sp:optsPub" />
		</wm:montageM>
	</xsl:template>
	
	<xsl:template match="of:optsPubFlashM">
		<wm:optsPubFlashM>
			<xsl:apply-templates select="@* | node()" />
		</wm:optsPubFlashM>
	</xsl:template>
	
	<xsl:template match="sp:illustrTransition">
		<sp:timeRangeTransition>
			<xsl:apply-templates select="@* | node()" />
		</sp:timeRangeTransition>
	</xsl:template>
	
	<xsl:template match="sp:summary">
		<sp:notice>
			<wm:notice>
				<wm:noticeM />
				<sp:summary>
					<xsl:apply-templates select="@* | node()" />
				</sp:summary>
			</wm:notice>
		</sp:notice>
	</xsl:template>

	<xsl:template match="sp:credits">
		<sp:extras>
			<xsl:apply-templates select="@* | node()" />
		</sp:extras>
	</xsl:template>
	
	<xsl:template match="@* | node()">
		<xsl:copy>
			<xsl:apply-templates select="@* | node()" />
		</xsl:copy>
	</xsl:template>
</xsl:stylesheet>