<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:sc="http://www.utc.fr/ics/scenari/v3/core"
	xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
	xmlns:of="scpf.org:office" xmlns:op="utc.fr:ics/opale3" xmlns:wm="scpf.org:webMedia" xmlns:sfm="http://www.utc.fr/ics/scenari/v3/filemeta">

	<xsl:output encoding="UTF-8" indent="yes" method="xml" />

	<xsl:template match="sfm:ogv/wm:altMediaM | sfm:flv/wm:altMediaM | sfm:webm/wm:altMediaM | sfm:mp4_f4v/wm:altMediaM">
		<wm:animM>
			<xsl:if test="sp:title">
				<sp:title>
					<xsl:value-of select="sp:title"/>
				</sp:title>
			</xsl:if>
			<sp:common>
				<wm:commonM/>
			</sp:common>
			<xsl:if test="sp:desc or sp:alt">
				<sp:alt>
					<of:altAnimM>
						<xsl:if test="sp:desc">
							<sp:transcript>
								<of:transcript>
									<sp:transcriptTxt>
										<of:sTxt>
											<xsl:copy-of select="sp:desc//sc:para"/>
										</of:sTxt>
									</sp:transcriptTxt>
								</of:transcript>
							</sp:transcript>
						</xsl:if>
						<xsl:if test="sp:alt">
							<sp:altTxt>
								<xsl:copy-of select="sp:alt//of:flow"/>
							</sp:altTxt>
						</xsl:if>
					</of:altAnimM>
				</sp:alt>
			</xsl:if>
			<xsl:if test="*[not(self::sp:title or self::sp:desc or self::sp:alt)]">
				<sp:altMedia>
					<wm:altMediaM>
						<xsl:copy-of select="*[not(self::sp:title or self::sp:desc or self::sp:alt)]"/>
					</wm:altMediaM>
				</sp:altMedia>
			</xsl:if>
 		</wm:animM>
	</xsl:template>

	<xsl:template match="sfm:mp3/wm:altMediaM | sfm:oga_ogg/wm:altMediaM">
		<wm:audioM>
			<xsl:if test="sp:title">
				<sp:title>
					<xsl:value-of select="sp:title"/>
				</sp:title>
			</xsl:if>
			<sp:common>
				<wm:commonM/>
			</sp:common>
			<xsl:if test="sp:desc or sp:alt">
				<sp:alt>
					<of:altAudioM>
						<xsl:if test="sp:desc">
							<sp:transcript>
								<of:transcript>
									<sp:transcriptTxt>
										<of:sTxt>
											<xsl:copy-of select="sp:desc//sc:para"/>
										</of:sTxt>
									</sp:transcriptTxt>
								</of:transcript>
							</sp:transcript>
						</xsl:if>
						<xsl:if test="sp:alt">
							<sp:altTxt>
								<xsl:copy-of select="sp:alt//of:flow"/>
							</sp:altTxt>
						</xsl:if>
					</of:altAudioM>
				</sp:alt>
			</xsl:if>
			<xsl:if test="*[not(self::sp:title or self::sp:desc or self::sp:alt)]">
				<sp:altMedia>
					<wm:altMediaM>
						<xsl:copy-of select="*[not(self::sp:title or self::sp:desc or self::sp:alt)]"/>
					</wm:altMediaM>
				</sp:altMedia>
			</xsl:if>
 		</wm:audioM>
	</xsl:template>
	
	<!-- Notice -->
	<xsl:template match="wm:noticeM/sp:author">
		<sp:author>
			<xsl:choose>
				<xsl:when test="contains(., ' ')">
					<sp:lastName>
						<xsl:value-of select="substring-after(., ' ')" />
					</sp:lastName>
					<sp:firstName>
						<xsl:value-of select="substring-before(., ' ')" />
					</sp:firstName>
				</xsl:when>
				<xsl:otherwise>
					<sp:lastName>
						<xsl:value-of select="." />
					</sp:lastName>
				</xsl:otherwise>
			</xsl:choose>
		</sp:author>
	</xsl:template>
	
	<xsl:template match="wm:noticeM/sp:dateOfPublication">
		<sp:date>
			<xsl:apply-templates select="node() | @*" />
		</sp:date>
	</xsl:template>
	
	<!-- optsPub -->
	<xsl:template match="wm:segmentM/sp:optsPub" />
	<xsl:template match="sp:optsPub/sp:flash" />
	<xsl:template match="wm:optsPubHtmlM/sp:autoplay" />

	<xsl:template match="node() | @*">
		<xsl:copy>
			<xsl:apply-templates select="node() | @*" />
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
