<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
	xmlns:of="scpf.org:office" xmlns:op="utc.fr:ics/opale3" xmlns:wm="scpf.org:webMedia" xmlns:sfm="http://www.utc.fr/ics/scenari/v3/filemeta" xmlns:redirect="com.scenari.src.helpers.util.xml.RedirectToSrc"
	extension-element-prefixes="redirect">

	<xsl:import href="utils.xsl" />

	<xsl:output encoding="UTF-8" indent="yes" method="xml" />

	<xsl:param name="pCurrentItem" />
	<xsl:param name="pCurrentItemUri" />

	<xsl:template match="sp:webMedia/@sc:refUri">
		<xsl:call-template name="tChangeRefUriExtension">
			<xsl:with-param name="pNewExtension" select="'seq'" />
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template match="sp:segmentationFull/@sc:refUri | wm:subSegmentRefM/sp:refItem/@sc:refUri">
		<xsl:call-template name="tChangeRefUriExtension">
			<xsl:with-param name="pNewExtension" select="'seg'" />
		</xsl:call-template>
	</xsl:template>

	<!-- Problème étrange de namespace sc non déclaré sur les metas de binaires -->
	<xsl:template match="sfm:*">
		<xsl:element name="sfm:{local-name()}" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core">
			<xsl:apply-templates select="node() | @*" />
		</xsl:element>
	</xsl:template>

	<xsl:template match="sp:altStream/@sc:refUri | sp:altOggWebM/@sc:refUri | sp:altMpeg/@sc:refUri">
		<xsl:call-template name="tChangeRefUriExtension">
			<xsl:with-param name="pOldExtension" select="'xml'" />
			<xsl:with-param name="pNewExtension" select="'stream'" />
		</xsl:call-template>
	</xsl:template>

	<xsl:template match="sp:notice/@sc:refUri">
		<xsl:call-template name="tChangeRefUriExtension">
			<xsl:with-param name="pNewExtension" select="'not'" />
		</xsl:call-template>
	</xsl:template>

	<xsl:template match="sp:transcript">
		<xsl:variable name="vRefUri">
			<xsl:call-template name="tChangeExtension">
				<xsl:with-param name="pFilename" select="substring-before($pCurrentItemUri, '/meta.xml')" />
				<xsl:with-param name="pNewExtension" select="'transc'" />
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="vBinFilename">
			<xsl:call-template name="tFilename">
				<xsl:with-param name="pPath" select="substring-before($pCurrentItemUri, '/meta.xml')" />
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="vFilename">
			<xsl:call-template name="tChangeExtension">
				<xsl:with-param name="pFilename" select="$vBinFilename" />
				<xsl:with-param name="pNewExtension" select="'transc'" />
			</xsl:call-template>
		</xsl:variable>

		<xsl:copy>
			<xsl:attribute name="sc:refUri">
	 			<xsl:value-of select="$vRefUri" />
	 		</xsl:attribute>
			<redirect:write file="../{$vFilename}">
				<sc:item>
					<xsl:attribute name="xmlns:sc">http://www.utc.fr/ics/scenari/v3/core</xsl:attribute>
					<xsl:attribute name="xmlns:sp">http://www.utc.fr/ics/scenari/v3/primitive</xsl:attribute>
					<xsl:attribute name="xmlns:wm">scpf.org:webMedia</xsl:attribute>
					<xsl:apply-templates select="of:transcript" />
				</sc:item>
			</redirect:write>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="sp:transcript[of:transcript/sp:transcriptTxt/@sc:refUri]">
		<xsl:copy>
			<xsl:apply-templates select="of:transcript/sp:transcriptTxt/@sc:refUri" />
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="of:transcript">
		<wm:transcript>
			<xsl:apply-templates select="node() | @*" />
		</wm:transcript>
	</xsl:template>

	<xsl:template match="node() | @*">
		<xsl:copy>
			<xsl:apply-templates select="node() | @*" />
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
