<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core">
	<xsl:template name="tExtension">
		<xsl:param name="pFilename" />

		<!-- Appel récursif du patron tant que l'extension contient un point -->
		<xsl:variable name="vExtension" select="substring-after($pFilename, '.')" />
		<xsl:choose>
			<xsl:when test="contains($vExtension,'.')">
				<xsl:call-template name="tExtension">
					<xsl:with-param name="pFilename" select="$vExtension" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$vExtension" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template name="tChangeExtension">
		<xsl:param name="pFilename" />
		<xsl:param name="pOldExtension" select="false()" />
		<xsl:param name="pNewExtension" select="false()" />

		<xsl:variable name="vExtension">
			<xsl:call-template name="tExtension">
				<xsl:with-param name="pFilename" select="$pFilename" />
			</xsl:call-template>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="not($pOldExtension) or $vExtension = $pOldExtension">
				<xsl:choose>
					<xsl:when test="$pNewExtension">
						<xsl:value-of select="concat(substring($pFilename, 1, string-length($pFilename) - string-length($vExtension)), $pNewExtension)" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="substring($pFilename, 1, string-length($pFilename) - string-length($vExtension) - 1)" />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$pFilename" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="tChangeRefUriExtension">
		<xsl:param name="pOldExtension" select="false()" />
		<xsl:param name="pNewExtension" select="false()" />
		
		<xsl:attribute name="sc:refUri">
				<xsl:choose>
					<xsl:when test="starts-with(., 'id:')">
						<xsl:value-of select="." />
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="tChangeExtension">
							<xsl:with-param name="pFilename" select="." />
							<xsl:with-param name="pOldExtension" select="$pOldExtension" />
							<xsl:with-param name="pNewExtension" select="$pNewExtension" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
	</xsl:template>
	
	<xsl:template name="tFilename">
		 <xsl:param name="pPath" />
		 <xsl:choose>
				 <xsl:when test="contains($pPath, '/')">
						 <xsl:call-template name="tFilename">
								 <xsl:with-param name="pPath" select="substring-after($pPath, '/')"/>
						 </xsl:call-template>
				 </xsl:when>
				 <xsl:otherwise>
						 <xsl:value-of select="$pPath"/>
				 </xsl:otherwise>
		 </xsl:choose>
 </xsl:template>
</xsl:stylesheet>
